Index: /code/branches/buildsystem2/cmake/BuildConfigMSVC.cmake
===================================================================
--- /code/branches/buildsystem2/cmake/BuildConfigMSVC.cmake	(revision 2642)
+++ /code/branches/buildsystem2/cmake/BuildConfigMSVC.cmake	(revision 2643)
@@ -116,3 +116,4 @@
 # CMake default flags: -MANIFEST -STACK:10000000 -machine:I386
 # and INCREMENTAL and DEBUG for debug versions
-ADD_LINKER_FLAGS("-OPT:REF -OPT:ICF -OPT:NOWIN98" Release MinSizeRel CACHE)
+ADD_LINKER_FLAGS("-OPT:REF -OPT:ICF" Release MinSizeRel CACHE)
+ADD_LINKER_FLAGS("-OPT:NOWIN98" MSVC80 CACHE)
Index: /code/branches/buildsystem2/cmake/FlagUtilities.cmake
===================================================================
--- /code/branches/buildsystem2/cmake/FlagUtilities.cmake	(revision 2642)
+++ /code/branches/buildsystem2/cmake/FlagUtilities.cmake	(revision 2643)
@@ -50,6 +50,6 @@
   IF(NOT DEFINED _INTERNAL_${_varname} OR "${_INTERNAL_${_varname}}" STREQUAL "${${_varname}}")
     SET(${_varname} "${_value}" CACHE ${_type} "${_docstring}" FORCE)
-  ENDIF()
-  SET(_INTERNAL_${_varname} "${_value}" CACHE INTERNAL "Do not edit in any case!")
+    SET(_INTERNAL_${_varname} "${_value}" CACHE INTERNAL "Do not edit in any case!")
+  ENDIF()
 ENDMACRO(SET_CACHE)
 
Index: /code/branches/buildsystem2/src/OrxonoxConfig.h.in
===================================================================
--- /code/branches/buildsystem2/src/OrxonoxConfig.h.in	(revision 2642)
+++ /code/branches/buildsystem2/src/OrxonoxConfig.h.in	(revision 2643)
@@ -27,4 +27,7 @@
  *   Original code: OgrePlatform.h, licensed under the LGPL. The code
  *   has changed almost completely though.
+ *
+ *   Caution: Do not configure this file CMake configuration (Debug, Release, etc.)
+ *            dependent! XCode and Visual Studio have the same file for all.
  *
  */
@@ -139,7 +142,4 @@
  * Includes
  *-------------------------------*/
-/* Set whether we must suffix "ceguilua/" for the CEGUILua.h include */
-#cmakedefine CEGUILUA_USE_INTERNAL_LIBRARY
-
 /* Define the english written operators like and, or, xor
  * This is C++ standard, but the Microsoft compiler doesn't define them. */
@@ -174,3 +174,37 @@
 #endif
 
+
+/*---------------------------------
+ * Various Settings
+ *-------------------------------*/
+/* Set whether we must suffix "ceguilua/" for the CEGUILua.h include */
+#cmakedefine CEGUILUA_USE_INTERNAL_LIBRARY
+
+/* Defined if a precompiled depdency package was used. We then copy all libraries
+   too when installing. */
+#cmakedefine USE_DEPENDENCY_PACKAGE
+
+/* Handle default ConfigValues */
+namespace orxonox
+{
+    const char* const ORXONOX_MEDIA_PATH("@ORXONOX_MEDIA_DIRECTORY@");
+    
+#ifdef NDEBUG
+    const char* const ORXONOX_OGRE_PLUGINS("@OGRE_PLUGINS_RELEASE@");
+#  ifdef USE_DEPENDENCY_PACKAGE
+    const char* const ORXONOX_OGRE_PLUGINS_FOLDER(".");
+#  elif
+    const char* const ORXONOX_OGRE_PLUGINS_FOLDER("@OGRE_PLUGINS_FOLDER_RELEASE@");
+#  endif
+#else
+    const char* const ORXONOX_OGRE_PLUGINS("@OGRE_PLUGINS_DEBUG@");
+#  ifdef USE_DEPENDENCY_PACKAGE
+    const char* const ORXONOX_OGRE_PLUGINS_FOLDER(".");
+#  elif
+    const char* const ORXONOX_OGRE_PLUGINS_FOLDER("@OGRE_PLUGINS_FOLDER_DEBUG@");
+#  endif
+#endif
+}
+
+
 #endif /* _OrxonoxConfig_H__ */
Index: /code/branches/buildsystem2/src/orxonox/CMakeLists.txt
===================================================================
--- /code/branches/buildsystem2/src/orxonox/CMakeLists.txt	(revision 2642)
+++ /code/branches/buildsystem2/src/orxonox/CMakeLists.txt	(revision 2643)
@@ -86,4 +86,6 @@
     SET(MSVC_PLATFORM "Win32")
   ENDIF()
+  STRING(REGEX REPLACE "^Visual Studio ([0-9][0-9]?) .*$" "\\1"
+         VISUAL_STUDIO_VERSION_SIMPLE "${CMAKE_GENERATOR}")
   CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/orxonox.vcproj.user" "${CMAKE_CURRENT_BINARY_DIR}/orxonox.vcproj.user")
 ENDIF(MSVC)
Index: /code/branches/buildsystem2/src/orxonox/Settings.cc
===================================================================
--- /code/branches/buildsystem2/src/orxonox/Settings.cc	(revision 2642)
+++ /code/branches/buildsystem2/src/orxonox/Settings.cc	(revision 2643)
@@ -63,5 +63,5 @@
     void Settings::setConfigValues()
     {
-        SetConfigValue(dataPath_, "../../../media/").description("Relative path to the game data.").callback(this, &Settings::dataPathChanged);
+        SetConfigValue(dataPath_, ORXONOX_MEDIA_PATH).description("Relative path to the game data.").callback(this, &Settings::dataPathChanged);
     }
 
Index: /code/branches/buildsystem2/src/orxonox/gamestates/GSGraphics.cc
===================================================================
--- /code/branches/buildsystem2/src/orxonox/gamestates/GSGraphics.cc	(revision 2642)
+++ /code/branches/buildsystem2/src/orxonox/gamestates/GSGraphics.cc	(revision 2643)
@@ -100,7 +100,7 @@
         SetConfigValue(ogreConfigFile_,  "ogre.cfg")
             .description("Location of the Ogre config file");
-        SetConfigValue(ogrePluginsFolder_, ".")
+        SetConfigValue(ogrePluginsFolder_, ORXONOX_OGRE_PLUGINS_FOLDER)
             .description("Folder where the Ogre plugins are located.");
-        SetConfigValue(ogrePlugins_, "RenderSystem_GL, Plugin_ParticleFX")
+        SetConfigValue(ogrePlugins_, ORXONOX_OGRE_PLUGINS)
             .description("Comma separated list of all plugins to load.");
         SetConfigValue(ogreLogFile_,     "ogre.log")
Index: /code/branches/buildsystem2/src/orxonox/orxonox.vcproj.user
===================================================================
--- /code/branches/buildsystem2/src/orxonox/orxonox.vcproj.user	(revision 2642)
+++ /code/branches/buildsystem2/src/orxonox/orxonox.vcproj.user	(revision 2643)
@@ -2,5 +2,5 @@
 <VisualStudioUserFile
 	ProjectType="Visual C++"
-	Version="8.00"
+	Version="${VISUAL_STUDIO_VERSION_SIMPLE}.00"
 	ShowAllFiles="false"
 	>