Index: code/branches/buildsystem2/cmake/FindALUT.cmake
===================================================================
--- code/branches/buildsystem2/cmake/FindALUT.cmake	(revision 2647)
+++ code/branches/buildsystem2/cmake/FindALUT.cmake	(revision 2648)
@@ -59,5 +59,5 @@
   )
   FIND_LIBRARY(ALUT_LIBRARY_DEBUG
-    NAMES alutd alut_d
+    NAMES alutd alut_d alutD alut_D
     PATHS $ENV{ALUTDIR}
     PATH_SUFFIXES lib libs
Index: code/branches/buildsystem2/cmake/FindCEGUI.cmake
===================================================================
--- code/branches/buildsystem2/cmake/FindCEGUI.cmake	(revision 2647)
+++ code/branches/buildsystem2/cmake/FindCEGUI.cmake	(revision 2648)
@@ -43,5 +43,7 @@
 )
 FIND_LIBRARY(CEGUI_LIBRARY_DEBUG
-  NAMES CEGUIBased CEGUIBase_d CEGUId CEGUI_d
+  NAMES
+    CEGUIBased CEGUIBase_d CEGUIBaseD CEGUIBase_D
+    CEGUId CEGUI_d CEGUID CEGUI_D
   PATHS $ENV{CEGUIDIR}
   PATH_SUFFIXES lib bin
Index: code/branches/buildsystem2/cmake/FindENet.cmake
===================================================================
--- code/branches/buildsystem2/cmake/FindENet.cmake	(revision 2647)
+++ code/branches/buildsystem2/cmake/FindENet.cmake	(revision 2648)
@@ -29,5 +29,5 @@
 )
 FIND_LIBRARY(ENET_LIBRARY_DEBUG
-  NAMES enetd enet_d
+  NAMES enetd enet_d enet_D
   PATHS $ENV{ENETDIR}
   PATH_SUFFIXES lib
Index: code/branches/buildsystem2/cmake/FindLua.cmake
===================================================================
--- code/branches/buildsystem2/cmake/FindLua.cmake	(revision 2647)
+++ code/branches/buildsystem2/cmake/FindLua.cmake	(revision 2648)
@@ -74,4 +74,5 @@
     FIND_LIBRARY(LUA_5.1_LIBRARY_DEBUG
       NAMES lua51d lua51_d lua5.1d lua5.1_d luad lua_d
+            lua51D lua51_D lua5.1D lua5.1_D luad lua_D
       PATHS $ENV{LUA_DIR}
       PATH_SUFFIXES lib64 lib
@@ -105,4 +106,5 @@
     FIND_LIBRARY(LUA_5.0_LUA_LIBRARY_DEBUG
       NAMES lua50d lua50_d lua5.0d lua5.0_d lua5d lua5_d luad lua_d
+            lua50D lua50_D lua5.0D lua5.0_D lua5d lua5_D luaD lua_D
       PATHS $ENV{LUA_DIR}
       PATH_SUFFIXES lib64 lib
@@ -123,4 +125,6 @@
         NAMES lualib50d lualib50_d lualib5.0d lualib5.0_d
 	      lualib5d lualib5_d lualibd lualib_d
+              lualib50D lualib50_D lualib5.0D lualib5.0_D
+	      lualib5D lualib5_D lualibD lualib_D
         PATHS $ENV{LUALIB_DIR} $ENV{LUA_DIR}
         PATH_SUFFIXES lib64 lib
Index: code/branches/buildsystem2/cmake/FindOGRE.cmake
===================================================================
--- code/branches/buildsystem2/cmake/FindOGRE.cmake	(revision 2647)
+++ code/branches/buildsystem2/cmake/FindOGRE.cmake	(revision 2648)
@@ -31,5 +31,5 @@
 )
 FIND_LIBRARY(OGRE_LIBRARY_DEBUG
-  NAMES OgreMaind OgreMain_d Ogred Ogre_d
+  NAMES OgreMaind OgreMain_d OgreMainD OgreMain_D Ogred Ogre_d OgreD Ogre_d
   PATHS $ENV{OGRE_HOME}
   PATH_SUFFIXES lib bin/Debug bin/debug Debug debug Versions/A
Index: code/branches/buildsystem2/cmake/FindOgg.cmake
===================================================================
--- code/branches/buildsystem2/cmake/FindOgg.cmake	(revision 2647)
+++ code/branches/buildsystem2/cmake/FindOgg.cmake	(revision 2648)
@@ -21,8 +21,4 @@
   PATH_SUFFIXES include
 )
-FIND_PATH(VORBIS_INCLUDE_DIR vorbis/codec.h
-  PATHS $ENV{OGGDIR}
-  PATH_SUFFIXES include
-)
 FIND_LIBRARY(OGG_LIBRARY_OPTIMIZED
   NAMES ogg
@@ -31,6 +27,6 @@
 )
 FIND_LIBRARY(OGG_LIBRARY_DEBUG
-  NAMES oggd ogg_d
-  PATHS $ENV{VORBISDIR}
+  NAMES oggd ogg_d oggD ogg_D
+  PATHS $ENV{OGGDIR}
   PATH_SUFFIXES lib
 )
Index: code/branches/buildsystem2/cmake/FindVorbis.cmake
===================================================================
--- code/branches/buildsystem2/cmake/FindVorbis.cmake	(revision 2647)
+++ code/branches/buildsystem2/cmake/FindVorbis.cmake	(revision 2648)
@@ -27,5 +27,5 @@
 )
 FIND_LIBRARY(VORBIS_LIBRARY_DEBUG
-  NAMES vorbisd vorbis_d
+  NAMES vorbisd vorbis_d vorbisD vorbis_D
   PATHS $ENV{VORBISDIR}
   PATH_SUFFIXES lib
@@ -37,5 +37,5 @@
 )
 FIND_LIBRARY(VORBISFILE_LIBRARY_DEBUG
-  NAMES vorbisfiled vorbisfile_d
+  NAMES vorbisfiled vorbisfile_d vorbisfileD vorbisfile_D
   PATHS $ENV{VORBISDIR}
   PATH_SUFFIXES lib