Index: /code/branches/buildsystem2/bin/CMakeLists.txt
===================================================================
--- /code/branches/buildsystem2/bin/CMakeLists.txt	(revision 2656)
+++ /code/branches/buildsystem2/bin/CMakeLists.txt	(revision 2657)
@@ -99,6 +99,9 @@
   IF(CMAKE_CONFIGURATION_TYPES)
     FOREACH(_configuration ${CMAKE_CONFIGURATION_TYPES})
-      INSTALL(FILES ${CMAKE_BINARY_DIR}/bin/${_configuration}/${_file}
-              DESTINATION bin CONFIGURATIONS ${_configuration})
+      INSTALL(
+        FILES ${CMAKE_BINARY_DIR}/bin/${_configuration}/${_file}
+        DESTINATION ${ORXONOX_RUNTIME_INSTALL_PATH}
+        CONFIGURATIONS ${_configuration}
+      )
     ENDFOREACH(_configuration)
   ELSE()
Index: /code/branches/buildsystem2/cmake/BuildConfig.cmake
===================================================================
--- /code/branches/buildsystem2/cmake/BuildConfig.cmake	(revision 2656)
+++ /code/branches/buildsystem2/cmake/BuildConfig.cmake	(revision 2657)
@@ -110,4 +110,44 @@
 
 
+############ Installation Settings ##############
+
+IF(UNIX)
+  SET(ORXONOX_RUNTIME_INSTALL_PATH ${CMAKE_INSTALL_PREFIX}/bin/orxonox)
+  SET(ORXONOX_LIBRARY_INSTALL_PATH ${CMAKE_INSTALL_PREFIX}/lib/orxonox)
+  SET(ORXONOX_ARCHIVE_INSTALL_PATH ${CMAKE_INSTALL_PREFIX}/lib/orxonox/static)
+  SET(ORXONOX_MEDIA_INSTALL_PATH   ${CMAKE_INSTALL_PREFIX}/share/orxonox)
+  SET(ORXONOX_DOC_INSTALL_PATH     ${CMAKE_INSTALL_PREFIX}/share/doc/orxonox)
+  # Not yet used
+  SET(ORXONOX_LOG_INSTALL_PATH     ~/.orxonox/log)
+  SET(ORXONOX_CONFIG_INSTALL_PATH  ~/.orxonox/config)
+ELSEIF(WIN32)
+  SET(ORXONOX_RUNTIME_INSTALL_PATH ${CMAKE_INSTALL_PREFIX}/bin)
+  SET(ORXONOX_LIBRARY_INSTALL_PATH ${CMAKE_INSTALL_PREFIX}/lib)
+  SET(ORXONOX_ARCHIVE_INSTALL_PATH ${CMAKE_INSTALL_PREFIX}/lib/static)
+  SET(ORXONOX_MEDIA_INSTALL_PATH   ${CMAKE_INSTALL_PREFIX}/media)
+  SET(ORXONOX_DOC_INSTALL_PATH     ${CMAKE_INSTALL_PREFIX}/doc)
+  # Not yet used
+  SET(ORXONOX_LOG_INSTALL_PATH     ${CMAKE_INSTALL_PREFIX}/log)
+  SET(ORXONOX_CONFIG_INSTALL_PATH  ${CMAKE_INSTALL_PREFIX}/config)
+ENDIF()
+
+
+################# Unix RPath ####################
+
+# use, i.e. don't skip the full RPATH for the build tree
+SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
+
+# when building, don't use the install RPATH already
+# (but later on when installing)
+SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
+
+# the RPATH to be used when installing
+SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+
+# add the automatically determined parts of the RPATH
+# which point to directories outside the build tree to the install RPATH
+SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+
+
 ####### Static/Dynamic linking defines ##########
 
Index: /code/branches/buildsystem2/cmake/InstallUtilities.cmake
===================================================================
--- /code/branches/buildsystem2/cmake/InstallUtilities.cmake	(revision 2656)
+++ /code/branches/buildsystem2/cmake/InstallUtilities.cmake	(revision 2657)
@@ -28,7 +28,7 @@
 FUNCTION(ORXONOX_INSTALL)
   INSTALL(TARGETS ${ARGN}
-    RUNTIME DESTINATION bin
-    LIBRARY DESTINATION lib
-    #ARCHIVE DESTINATION lib
+    RUNTIME DESTINATION ${ORXONOX_RUNTIME_INSTALL_PATH}
+    LIBRARY DESTINATION ${ORXONOX_LIBRARY_INSTALL_PATH}
+    #ARCHIVE DESTINATION ${ORXONOX_ARCHIVE_INSTALL_PATH}
   )
 ENDFUNCTION(ORXONOX_INSTALL)
Index: /code/branches/buildsystem2/doc/api/CMakeLists.txt
===================================================================
--- /code/branches/buildsystem2/doc/api/CMakeLists.txt	(revision 2656)
+++ /code/branches/buildsystem2/doc/api/CMakeLists.txt	(revision 2657)
@@ -73,3 +73,15 @@
     ENDIF(HTML_HELP_COMPILER)
   ENDIF (WIN32) 
+
+
+  # Installation
+  INSTALL(
+    FILES ${DOXY_CONFIG} ${CMAKE_CURRENT_BINARY_DIR}/doxy.log
+    DESTINATION ${ORXONOX_DOC_INSTALL_PATH}/api
+    OPTIONAL
+  )
+  INSTALL(
+    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
+    DESTINATION ${ORXONOX_DOC_INSTALL_PATH}/api
+  )
 ENDIF(DOXYGEN_FOUND)
Index: /code/branches/buildsystem2/media/CMakeLists.txt
===================================================================
--- /code/branches/buildsystem2/media/CMakeLists.txt	(revision 2656)
+++ /code/branches/buildsystem2/media/CMakeLists.txt	(revision 2657)
@@ -40,12 +40,7 @@
 ################ Installation #################
 
-IF(UNIX)
-  SET(MEDIA_INSTALL_SUFFIX "share/orxonox")
-ELSEIF(WIN32)
-  SET(MEDIA_INSTALL_SUFFIX "media")
-ELSE()
-  MESSAGE(FATAL_ERROR "Install location for media files not yet specified for this platform. Please Adjust root/media/CMakeLists.txt")
-ENDIF()
-
-INSTALL(DIRECTORY ${ORXONOX_MEDIA_DIRECTORY}/ DESTINATION
-        ${MEDIA_INSTALL_SUFFIX} REGEX "\\.svn$|_svn$" EXCLUDE)
+INSTALL(
+  DIRECTORY ${ORXONOX_MEDIA_DIRECTORY}/
+  DESTINATION ${ORXONOX_MEDIA_INSTALL_PATH}
+  REGEX "\\.svn$|_svn$" EXCLUDE
+)