Index: code/branches/buildsystem3/src/core/Factory.h
===================================================================
--- code/branches/buildsystem3/src/core/Factory.h	(revision 2665)
+++ code/branches/buildsystem3/src/core/Factory.h	(revision 2667)
@@ -49,5 +49,4 @@
 #include <map>
 #include <string>
-#include "util/Integers.h"
 
 namespace orxonox
Index: code/branches/buildsystem3/src/core/Identifier.h
===================================================================
--- code/branches/buildsystem3/src/core/Identifier.h	(revision 2665)
+++ code/branches/buildsystem3/src/core/Identifier.h	(revision 2667)
@@ -68,5 +68,4 @@
 #include "Super.h"
 #include "Functor.h"
-#include "util/Integers.h"
 #include "util/Debug.h"
 #include "util/String.h"
Index: code/branches/buildsystem3/src/core/RootGameState.cc
===================================================================
--- code/branches/buildsystem3/src/core/RootGameState.cc	(revision 2665)
+++ code/branches/buildsystem3/src/core/RootGameState.cc	(revision 2667)
@@ -135,5 +135,5 @@
     {
         // Don't catch errors when having a debugger in msvc
-#if ORXONOX_COMPILER != ORXONOX_COMPILER_MSVC || defined(NDEBUG)
+#if !defined(ORXONOX_COMPILER_MSVC) || defined(NDEBUG)
         try
         {
@@ -158,5 +158,5 @@
 
             this->deactivate();
-#if ORXONOX_COMPILER != ORXONOX_COMPILER_MSVC || defined(NDEBUG)
+#if !defined(ORXONOX_COMPILER_MSVC) || defined(NDEBUG)
         }
         // Note: These are all unhandled exceptions that should not have made its way here!
Index: code/branches/buildsystem3/src/network/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/network/CMakeLists.txt	(revision 2665)
+++ code/branches/buildsystem3/src/network/CMakeLists.txt	(revision 2667)
@@ -34,9 +34,9 @@
 )
 ADD_SUBDIRECTORY(packet)
+ADD_SUBDIRECTORY(synchronisable)
 GET_ALL_HEADER_FILES(NETWORK_HDR_FILES)
 SET(NETWORK_FILES ${NETWORK_SRC_FILES} ${NETWORK_HDR_FILES})
 
 GENERATE_SOURCE_GROUPS(${NETWORK_FILES})
-ADD_SOURCE_DIRECTORY(NETWORK_SRC_FILES synchronisable)
 
 ADD_LIBRARY(network SHARED ${NETWORK_FILES})
Index: code/branches/buildsystem3/src/network/NetworkPrereqs.h
===================================================================
--- code/branches/buildsystem3/src/network/NetworkPrereqs.h	(revision 2665)
+++ code/branches/buildsystem3/src/network/NetworkPrereqs.h	(revision 2667)
@@ -57,9 +57,4 @@
 
 //-----------------------------------------------------------------------
-// Includes
-//-----------------------------------------------------------------------
-#include "util/Integers.h"
-
-//-----------------------------------------------------------------------
 // Library global contants
 //-----------------------------------------------------------------------
Index: code/branches/buildsystem3/src/network/TrafficControl.h
===================================================================
--- code/branches/buildsystem3/src/network/TrafficControl.h	(revision 2665)
+++ code/branches/buildsystem3/src/network/TrafficControl.h	(revision 2667)
@@ -36,5 +36,4 @@
 #include <utility>
 #include <algorithm>
-#include "util/Integers.h"
 #include "core/OrxonoxClass.h"
 #include "network/ClientConnectionListener.h"
Index: code/branches/buildsystem3/src/network/synchronisable/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/network/synchronisable/CMakeLists.txt	(revision 2665)
+++ code/branches/buildsystem3/src/network/synchronisable/CMakeLists.txt	(revision 2667)
@@ -1,3 +1,3 @@
-SET( SRC_FILES
+ADD_SOURCE_FILES(NETWORK_SRC_FILES
   NetworkCallbackManager.cc
   Synchronisable.cc
@@ -5,4 +5,2 @@
   SynchronisableVariable.cc
 )
-
-ADD_SOURCE_FILES(SRC_FILES)
Index: code/branches/buildsystem3/src/network/synchronisable/SynchronisableVariable.h
===================================================================
--- code/branches/buildsystem3/src/network/synchronisable/SynchronisableVariable.h	(revision 2665)
+++ code/branches/buildsystem3/src/network/synchronisable/SynchronisableVariable.h	(revision 2667)
@@ -35,5 +35,4 @@
 #include <string>
 #include <cassert>
-#include "util/Integers.h"
 #include "core/Core.h"
 #include "core/CoreIncludes.h"
Index: code/branches/buildsystem3/src/orxonox/objects/worldentities/Planet.cc
===================================================================
--- code/branches/buildsystem3/src/orxonox/objects/worldentities/Planet.cc	(revision 2665)
+++ code/branches/buildsystem3/src/orxonox/objects/worldentities/Planet.cc	(revision 2667)
@@ -74,10 +74,10 @@
         if(activeCamera)
         {
-            Real distance = this->getPosition().distance( activeCamera->getWorldPosition() );
+            float distance = this->getPosition().distance( activeCamera->getWorldPosition() );
             //             COUT(2) << distance << std::endl;
-            Real planetRadius = this->getScale();
+            float planetRadius = this->getScale();
 
-            Real newScale = 2 * distance / sqrt(distance*distance - planetRadius*planetRadius);
-            Real tempTest = newScale*(1+Real(this->atmosphereSize)/Real(this->imageSize));
+            float newScale = 2 * distance / sqrt(distance*distance - planetRadius*planetRadius);
+            float tempTest = newScale*(1+float(this->atmosphereSize)/float(this->imageSize));
             newScale = tempTest;
 
@@ -90,5 +90,5 @@
     void Planet::init()
     {
-        Real scaleFactor = this->getScale();
+        float scaleFactor = this->getScale();
 
         this->distList.push_back(10.0*scaleFactor);
@@ -103,5 +103,5 @@
         this->distList.push_back(55.0*scaleFactor);
 
-        Real reductionValue = 0.2;
+        float reductionValue = 0.2;
 
         this->mesh_.getEntity()->getMesh()->generateLodLevels(distList, Ogre::ProgressiveMesh::VRQ_PROPORTIONAL, reductionValue);
Index: code/branches/buildsystem3/src/orxonox/objects/worldentities/Planet.h
===================================================================
--- code/branches/buildsystem3/src/orxonox/objects/worldentities/Planet.h	(revision 2665)
+++ code/branches/buildsystem3/src/orxonox/objects/worldentities/Planet.h	(revision 2667)
@@ -71,9 +71,9 @@
             }
             
-            inline void setAtmosphereSize(Real size){
+            inline void setAtmosphereSize(float size){
                 this->atmosphereSize = size;
             }
             
-            inline Real getAtmosphereSize(){
+            inline float getAtmosphereSize(){
                 return this->atmosphereSize;
             }
@@ -87,9 +87,9 @@
             }
             
-            inline void setImageSize(Real size){
+            inline void setImageSize(float size){
                 this->imageSize = size;
             }
             
-            inline Real getImageSize(){
+            inline float getImageSize(){
                 return this->imageSize;
             }
@@ -106,6 +106,6 @@
             std::string atmosphere_;
             Mesh mesh_;
-            Real atmosphereSize;
-            Real imageSize;
+            float atmosphereSize;
+            float imageSize;
             Ogre::Mesh::LodDistanceList distList;
             BillboardSet billboard_;