Index: code/branches/buildsystem3/doc/api/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/doc/api/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/doc/api/CMakeLists.txt	(revision 2670)
@@ -65,10 +65,7 @@
       STRING(REGEX REPLACE "/" "\\\\" HHP_FILE ${TMP})
       ADD_CUSTOM_TARGET(chmdoc ${HTML_HELP_COMPILER} ${HHP_FILE})
-      IF(NOT MSVC)
-        ADD_DEPENDENCIES(chmdoc doc)
-      ELSE(NOT MSVC)
-        # Do not add the dependency because msvc will then always build
-        # Doxygen, which is not very comforting.
-      ENDIF(NOT MSVC)
+      ADD_DEPENDENCIES(chmdoc doc)
+      # Adding a dependency somehow adds doc target as default build target
+      SET_TARGET_PROPERTIES(doc chmdoc PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD TRUE)
     ENDIF(HTML_HELP_COMPILER)
   ENDIF (WIN32) 
@@ -81,9 +78,11 @@
     OPTIONAL
   )
-  IF(EXISTS ${CMAAKE_CURRENT_BINARY_DIR}/html)
-    INSTALL(
-      DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
-      DESTINATION ${ORXONOX_DOC_INSTALL_PATH}/api
-    )
+  # Install command always needs the directory to work
+  IF(NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/html)
+    FILE(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html)
   ENDIF()
+  INSTALL(
+    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
+    DESTINATION ${ORXONOX_DOC_INSTALL_PATH}/api
+  )
 ENDIF(DOXYGEN_FOUND)
Index: code/branches/buildsystem3/media/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/media/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/media/CMakeLists.txt	(revision 2670)
@@ -41,7 +41,14 @@
 ################ Installation #################
 
+# Try no to copy both tcl script file libraries
+IF(TCL_LIBRARY MATCHES "85|8\\.5")
+  SET(TCL_EXCLUDE_PATTERN "tcl8\\.4")
+ELSEIF(TCL_LIBRARY MATCHES "84|8\\.4")
+  SET(TCL_EXCLUDE_PATTERN "tcl8\\.5")
+ENDIF()
+
 INSTALL(
   DIRECTORY ${ORXONOX_MEDIA_DIRECTORY}/
   DESTINATION ${ORXONOX_MEDIA_INSTALL_PATH}
-  REGEX "\\.svn$|_svn$" EXCLUDE
+  REGEX "\\.svn$|_svn$|backToPNG|${TCL_EXCLUDE_PATTERN}" EXCLUDE
 )
Index: code/branches/buildsystem3/src/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/src/CMakeLists.txt	(revision 2670)
@@ -133,2 +133,6 @@
 ADD_SUBDIRECTORY(network)
 ADD_SUBDIRECTORY(orxonox)
+
+# Apply version info
+SET_TARGET_PROPERTIES(util core network orxonox
+  PROPERTIES VERSION ${ORXONOX_VERSION})
Index: code/branches/buildsystem3/src/bullet/BulletCollision/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/bullet/BulletCollision/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/src/bullet/BulletCollision/CMakeLists.txt	(revision 2670)
@@ -1,3 +1,3 @@
-SET(BulletCollision_SRCS
+ADD_SOURCE_FILES(BULLET_FILES
 	BroadphaseCollision/btAxisSweep3.cpp
 	BroadphaseCollision/btBroadphaseProxy.cpp
@@ -10,4 +10,5 @@
 	BroadphaseCollision/btQuantizedBvh.cpp
 	BroadphaseCollision/btSimpleBroadphase.cpp
+
 	CollisionDispatch/btActivatingCollisionAlgorithm.cpp
 	CollisionDispatch/btCollisionDispatcher.cpp
@@ -30,4 +31,5 @@
 	CollisionDispatch/btUnionFind.cpp
 	CollisionDispatch/SphereTriangleDetector.cpp
+
 	CollisionShapes/btBoxShape.cpp
 	CollisionShapes/btBvhTriangleMeshShape.cpp
@@ -63,4 +65,5 @@
 	CollisionShapes/btTriangleMeshShape.cpp
 	CollisionShapes/btUniformScalingShape.cpp
+
 	Gimpact/btContactProcessing.cpp
 	Gimpact/btGImpactShape.cpp
@@ -74,4 +77,5 @@
 	Gimpact/btGImpactQuantizedBvh.cpp
 	Gimpact/gim_box_set.cpp
+
 	NarrowPhaseCollision/btContinuousConvexCollision.cpp
 	NarrowPhaseCollision/btGjkEpa2.cpp
@@ -85,5 +89,104 @@
 	NarrowPhaseCollision/btSubSimplexConvexCast.cpp
 	NarrowPhaseCollision/btVoronoiSimplexSolver.cpp
+
+	# Headers
+	BroadphaseCollision/btAxisSweep3.h
+	BroadphaseCollision/btBroadphaseInterface.h
+	BroadphaseCollision/btBroadphaseProxy.h
+	BroadphaseCollision/btCollisionAlgorithm.h
+	BroadphaseCollision/btDispatcher.h
+	BroadphaseCollision/btDbvtBroadphase.h
+	BroadphaseCollision/btDbvt.h
+	BroadphaseCollision/btMultiSapBroadphase.h
+	BroadphaseCollision/btOverlappingPairCache.h
+	BroadphaseCollision/btOverlappingPairCallback.h
+	BroadphaseCollision/btQuantizedBvh.h
+	BroadphaseCollision/btSimpleBroadphase.h
+
+	CollisionDispatch/btActivatingCollisionAlgorithm.h
+	CollisionDispatch/btCollisionConfiguration.h
+	CollisionDispatch/btCollisionCreateFunc.h
+	CollisionDispatch/btCollisionDispatcher.h
+	CollisionDispatch/btCollisionObject.h
+	CollisionDispatch/btCollisionWorld.h
+	CollisionDispatch/btCompoundCollisionAlgorithm.h
+	CollisionDispatch/btConvexConcaveCollisionAlgorithm.h
+	CollisionDispatch/btDefaultCollisionConfiguration.h
+	CollisionDispatch/btSphereSphereCollisionAlgorithm.h
+	CollisionDispatch/btBoxBoxCollisionAlgorithm.h
+	CollisionDispatch/btBoxBoxDetector.h
+	CollisionDispatch/btGhostObject.h
+	CollisionDispatch/btSphereBoxCollisionAlgorithm.h
+	CollisionDispatch/btConvexPlaneCollisionAlgorithm.h
+	CollisionDispatch/btSphereTriangleCollisionAlgorithm.h
+	CollisionDispatch/btConvexConvexAlgorithm.h
+	CollisionDispatch/btEmptyCollisionAlgorithm.h
+	CollisionDispatch/btManifoldResult.h
+	CollisionDispatch/btSimulationIslandManager.h
+	CollisionDispatch/btUnionFind.h
+	CollisionDispatch/SphereTriangleDetector.h
+
+	CollisionShapes/btBoxShape.h
+	CollisionShapes/btBvhTriangleMeshShape.h
+	CollisionShapes/btCapsuleShape.h
+	CollisionShapes/btCollisionMargin
+	CollisionShapes/btCollisionShape.h
+	CollisionShapes/btCompoundShape.h
+	CollisionShapes/btConcaveShape.h
+	CollisionShapes/btConeShape.h
+	CollisionShapes/btConvexHullShape.h
+	CollisionShapes/btConvexPointCloudShape.h
+	CollisionShapes/btConvexShape.h
+	CollisionShapes/btConvexInternalShape.h
+	CollisionShapes/btConvexTriangleMeshShape.h
+	CollisionShapes/btCylinderShape.h
+	CollisionShapes/btEmptyShape.h
+	CollisionShapes/btHeightfieldTerrainShape.h
+	CollisionShapes/btMinkowskiSumShape.h
+	CollisionShapes/btMaterial.h
+	CollisionShapes/btMultimaterialTriangleMeshShape.h
+	CollisionShapes/btMultiSphereShape.h
+	CollisionShapes/btOptimizedBvh.h
+	CollisionShapes/btPolyhedralConvexShape.h
+	CollisionShapes/btScaledBvhTriangleMeshShape.h
+	CollisionShapes/btTetrahedronShape.h
+	CollisionShapes/btSphereShape.h
+	CollisionShapes/btShapeHull.h
+	CollisionShapes/btStaticPlaneShape.h
+	CollisionShapes/btStridingMeshInterface.h
+	CollisionShapes/btTriangleCallback.h
+	CollisionShapes/btTriangleBuffer.h
+	CollisionShapes/btTriangleIndexVertexArray.h
+	CollisionShapes/btTriangleIndexVertexMaterialArray.h
+	CollisionShapes/btTriangleMesh.h
+	CollisionShapes/btTriangleMeshShape.h
+	CollisionShapes/btUniformScalingShape.h
+
+	Gimpact/btGImpactShape.h
+	Gimpact/gim_contact.h
+	Gimpact/btGImpactBvh.h
+	Gimpact/btGenericPoolAllocator.h
+	Gimpact/gim_memory.h
+	Gimpact/btGImpactCollisionAlgorithm.h
+	Gimpact/btTriangleShapeEx.h
+	Gimpact/gim_tri_collision.h
+	Gimpact/btGImpactQuantizedBvh.h
+	Gimpact/gim_box_set.h
+
+	NarrowPhaseCollision/btContinuousConvexCollision.h
+	NarrowPhaseCollision/btConvexCast.h
+	NarrowPhaseCollision/btConvexPenetrationDepthSolver.h
+	NarrowPhaseCollision/btDiscreteCollisionDetectorInterface.h
+	NarrowPhaseCollision/btGjkConvexCast.h
+	NarrowPhaseCollision/btGjkEpa2.h
+	NarrowPhaseCollision/btGjkEpaPenetrationDepthSolver.h
+	NarrowPhaseCollision/btGjkPairDetector.h
+	NarrowPhaseCollision/btManifoldPoint.h
+	NarrowPhaseCollision/btMinkowskiPenetrationDepthSolver.h
+	NarrowPhaseCollision/btPersistentManifold.h
+	NarrowPhaseCollision/btPointCollector.h
+	NarrowPhaseCollision/btRaycastCallback.h
+	NarrowPhaseCollision/btSimplexSolverInterface.h
+	NarrowPhaseCollision/btSubSimplexConvexCast.h
+	NarrowPhaseCollision/btVoronoiSimplexSolver.h
 )
-
-ADD_LIBRARY(BulletCollision ${BulletCollision_SRCS})
Index: code/branches/buildsystem3/src/bullet/BulletDynamics/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/bullet/BulletDynamics/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/src/bullet/BulletDynamics/CMakeLists.txt	(revision 2670)
@@ -1,3 +1,3 @@
-SET(BulletDynamics_SRCS
+ADD_SOURCE_FILES(BULLET_FILES
 	ConstraintSolver/btContactConstraint.cpp
 	ConstraintSolver/btConeTwistConstraint.cpp
@@ -9,12 +9,42 @@
 	ConstraintSolver/btSolve2LinearConstraint.cpp
 	ConstraintSolver/btTypedConstraint.cpp
+
 	Dynamics/Bullet-C-API.cpp
 	Dynamics/btDiscreteDynamicsWorld.cpp
 	Dynamics/btSimpleDynamicsWorld.cpp
 	Dynamics/btRigidBody.cpp
+
 	Vehicle/btRaycastVehicle.cpp
 	Vehicle/btWheelInfo.cpp
+
 	Character/btKinematicCharacterController.cpp
+
+	# Headers
+	ConstraintSolver/btConstraintSolver.h
+	ConstraintSolver/btContactConstraint.h
+	ConstraintSolver/btContactSolverInfo.h
+	ConstraintSolver/btConeTwistConstraint.h
+	ConstraintSolver/btGeneric6DofConstraint.h
+	ConstraintSolver/btHingeConstraint.h
+	ConstraintSolver/btJacobianEntry.h
+	ConstraintSolver/btPoint2PointConstraint.h
+	ConstraintSolver/btSequentialImpulseConstraintSolver.h
+	ConstraintSolver/btSliderConstraint.h
+	ConstraintSolver/btSolve2LinearConstraint.h
+	ConstraintSolver/btSolverBody.h
+	ConstraintSolver/btSolverConstraint.h
+	ConstraintSolver/btTypedConstraint.h
+
+	Dynamics/btContinuousDynamicsWorld.h
+	Dynamics/btDiscreteDynamicsWorld.h
+	Dynamics/btDynamicsWorld.h
+	Dynamics/btSimpleDynamicsWorld.h
+	Dynamics/btRigidBody.h
+
+	Vehicle/btRaycastVehicle.h
+	Vehicle/btVehicleRaycaster.h
+	Vehicle/btWheelInfo.h
+
+	Character/btCharacterControllerInterface.h
+	Character/btKinematicCharacterController.h
 )
-
-ADD_LIBRARY(BulletDynamics ${BulletDynamics_SRCS})
Index: code/branches/buildsystem3/src/bullet/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/bullet/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/src/bullet/CMakeLists.txt	(revision 2670)
@@ -1,3 +1,41 @@
+ #
+ #             ORXONOX - the hottest 3D action shooter ever to exist
+ #                             > www.orxonox.net <
+ #
+ #        This program is free software; you can redistribute it and/or
+ #         modify it under the terms of the GNU General Public License
+ #        as published by the Free Software Foundation; either version 2
+ #            of the License, or (at your option) any later version.
+ #
+ #       This program is distributed in the hope that it will be useful,
+ #        but WITHOUT ANY WARRANTY; without even the implied warranty of
+ #        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ #                 GNU General Public License for more details.
+ #
+ #   You should have received a copy of the GNU General Public License along
+ #      with this program; if not, write to the Free Software Foundation,
+ #     Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ #
+
+SET_SOURCE_FILES(BULLET_FILES
+  btBulletCollisionCommon.h
+  btBulletDynamicsCommon.h
+  Bullet-C-Api.h
+)
 ADD_SUBDIRECTORY(BulletCollision)
 ADD_SUBDIRECTORY(BulletDynamics)
 ADD_SUBDIRECTORY(LinearMath)
+
+GENERATE_SOURCE_GROUPS(${BULLET_FILES})
+
+# No warnings needed from third party libraries
+ADD_COMPILER_FLAGS("-w")
+
+IF(MSVC)
+  ADD_LIBRARY(bullet_orxonox STATIC ${BULLET_FILES})
+ELSE(MSVC)
+  ADD_LIBRARY(bullet_orxonox SHARED ${BULLET_FILES})
+  ORXONOX_INSTALL(bullet_orxonox)
+ENDIF(MSVC)
+
+SET_TARGET_PROPERTIES(bullet_orxonox PROPERTIES VERSION 2.73)
Index: code/branches/buildsystem3/src/bullet/LinearMath/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/bullet/LinearMath/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/src/bullet/LinearMath/CMakeLists.txt	(revision 2670)
@@ -1,8 +1,30 @@
-SET(LinearMath_SRCS
+ADD_SOURCE_FILES(BULLET_FILES
 		btConvexHull.cpp
 		btQuickprof.cpp
 		btGeometryUtil.cpp
 		btAlignedAllocator.cpp
+
+		# Headers
+		btAlignedObjectArray.h
+		btList.h
+		btPoolAllocator.h
+		btRandom.h
+		btVector3.h
+		btDefaultMotionState.h
+		btMatrix3x3.h
+		btQuadWord.h
+		btHashMap.h
+		btScalar.h
+		btAabbUtil2.h
+		btConvexHull.h
+		btMinMax.h
+		btQuaternion.h
+		btStackAlloc.h
+		btGeometryUtil.h
+		btMotionState.h
+		btTransform.h
+		btAlignedAllocator.h
+		btIDebugDraw.h
+		btQuickprof.h
+		btTransformUtil.h
 )
-
-ADD_LIBRARY(LinearMath ${LinearMath_SRCS})
Index: code/branches/buildsystem3/src/bullet/changes_orxonox.diff
===================================================================
--- code/branches/buildsystem3/src/bullet/changes_orxonox.diff	(revision 2670)
+++ code/branches/buildsystem3/src/bullet/changes_orxonox.diff	(revision 2670)
@@ -0,0 +1,15 @@
+--- LinearMath\btScalar.h	So Feb 15 18:28:13 2009
++++ LinearMath\btScalar.h	Sa Feb 14 23:04:53 2009
+@@ -227,7 +227,11 @@
+ SIMD_FORCE_INLINE btScalar btAtan2(btScalar x, btScalar y) { return atan2f(x, y); }
+ SIMD_FORCE_INLINE btScalar btExp(btScalar x) { return expf(x); }
+ SIMD_FORCE_INLINE btScalar btLog(btScalar x) { return logf(x); }
+-SIMD_FORCE_INLINE btScalar btPow(btScalar x,btScalar y) { return powf(x,y); }
++  #if defined( __MINGW32__ )
++  SIMD_FORCE_INLINE btScalar btPow(btScalar x,btScalar y) { return pow(x,y); }
++  #else
++  SIMD_FORCE_INLINE btScalar btPow(btScalar x,btScalar y) { return powf(x,y); }
++  #endif
+ 
+ #endif
+ 
Index: code/branches/buildsystem3/src/ceguilua/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/ceguilua/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/src/ceguilua/CMakeLists.txt	(revision 2670)
@@ -36,15 +36,20 @@
 # Copy package files incrementally until the version is met
 SET(CEGUILUA_VERSIONS 0.5.0 0.6.0 0.6.1 0.6.2)
-FOREACH(_version ${CEGUILUA_VERSIONS})
-  COMPARE_VERSION_STRINGS(${_version} ${CEGUI_VERSION} _compare_result)
-  IF(_compare_result EQUAL 1)
-    BREAK() # _version > CEGUI_VERSION
-  ENDIF()
+# Only copy on version change
+IF(NOT "${_CEGUI_VERSION_REF}" STREQUAL "${CEGUI_VERSION}"
+   OR NOT EXISTS ${CEGUILUA_BINARY_DIR}/exceptions.lua)
+  SET(_CEGUI_VERSION_REF ${CEGUI_VERSION} CACHE INTERNAL "Do not edit")
+  FOREACH(_version ${CEGUILUA_VERSIONS})
+    COMPARE_VERSION_STRINGS(${_version} ${CEGUI_VERSION} _compare_result)
+    IF(_compare_result EQUAL 1)
+      BREAK() # _version > CEGUI_VERSION
+    ENDIF()
   
-  ADD_SUBDIRECTORY(ceguilua-${_version}) # Sets parent scope variable
-  FOREACH(_file ${_package_files})
-    CONFIGURE_FILE(ceguilua-${_version}/package/${_file} ${CEGUILUA_BINARY_DIR}/${_file} COPYONLY)
-  ENDFOREACH(_file)
-ENDFOREACH(_version)
+    ADD_SUBDIRECTORY(ceguilua-${_version}) # Sets parent scope variable _package_files
+    FOREACH(_file ${_package_files})
+      CONFIGURE_FILE(ceguilua-${_version}/package/${_file} ${CEGUILUA_BINARY_DIR}/${_file} COPYONLY)
+    ENDFOREACH(_file)
+  ENDFOREACH(_version)
+ENDIF()
 
 # Create the tolua bind file. We could use the orignal file though, but it is 1.6MB...
@@ -62,5 +67,6 @@
 )
 
-ADD_COMPILER_FLAGS("-w44996" MSVC)
+# No warnings needed from third party libraries
+ADD_COMPILER_FLAGS("-w")
 
 SOURCE_GROUP("Source" FILES ${CEGUILUA_FILES})
@@ -76,3 +82,5 @@
 )
 
+SET_TARGET_PROPERTIES(ceguilua_orxonox PROPERTIES VERSION ${CEGUI_VERSION})
+
 ORXONOX_INSTALL(ceguilua_orxonox)
Index: code/branches/buildsystem3/src/cpptcl/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/cpptcl/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/src/cpptcl/CMakeLists.txt	(revision 2670)
@@ -33,4 +33,7 @@
 GENERATE_SOURCE_GROUPS(${CPPTCL_FILES})
 
+# No warnings needed from third party libraries
+ADD_COMPILER_FLAGS("-w")
+
 IF(MSVC)
   ADD_LIBRARY(cpptcl_orxonox STATIC ${CPPTCL_FILES})
@@ -41,2 +44,4 @@
 
 TARGET_LINK_LIBRARIES(cpptcl_orxonox ${TCL_LIBRARY})
+
+SET_TARGET_PROPERTIES(cpptcl_orxonox PROPERTIES VERSION 1.1.3)
Index: code/branches/buildsystem3/src/ogreceguirenderer/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/ogreceguirenderer/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/src/ogreceguirenderer/CMakeLists.txt	(revision 2670)
@@ -29,4 +29,7 @@
 GENERATE_SOURCE_GROUPS(${OCR_FILES})
 
+# No warnings needed from third party libraries
+ADD_COMPILER_FLAGS("-w")
+
 ADD_LIBRARY(ogreceguirenderer_orxonox SHARED ${OCR_FILES})
 SET_TARGET_PROPERTIES(ogreceguirenderer_orxonox PROPERTIES DEFINE_SYMBOL "OGRE_GUIRENDERER_EXPORTS")
@@ -36,3 +39,5 @@
 )
 
+SET_TARGET_PROPERTIES(ogreceguirenderer_orxonox PROPERTIES VERSION 1.4.9)
+
 ORXONOX_INSTALL(ogreceguirenderer_orxonox)
Index: code/branches/buildsystem3/src/ois/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/ois/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/src/ois/CMakeLists.txt	(revision 2670)
@@ -52,5 +52,9 @@
 GENERATE_SOURCE_GROUPS(${OIS_FILES})
 
+# No warnings needed from third party libraries
+ADD_COMPILER_FLAGS("-w")
+# Multibyte character required for OIS
 REMOVE_COMPILER_FLAGS("-DUNICODE -D_UNICODE" MSVC)
+
 INCLUDE_DIRECTORIES(.)
 
@@ -62,3 +66,5 @@
 ENDIF()
 
+SET_TARGET_PROPERTIES(ois_orxonox PROPERTIES VERSION 1.2)
+
 ORXONOX_INSTALL(ois_orxonox)
Index: code/branches/buildsystem3/src/orxonox/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/orxonox/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/src/orxonox/CMakeLists.txt	(revision 2670)
@@ -69,7 +69,5 @@
   tinyxml++_orxonox
   tolua++_orxonox
-  BulletDynamics
-  BulletCollision
-  LinearMath
+  bullet_orxonox
   util
   core
Index: code/branches/buildsystem3/src/tinyxml/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/tinyxml/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/src/tinyxml/CMakeLists.txt	(revision 2670)
@@ -32,4 +32,7 @@
 GENERATE_SOURCE_GROUPS(${TINYXML++_FILES})
 
+# No warnings needed from third party libraries
+ADD_COMPILER_FLAGS("-w")
+
 IF(MSVC)
   ADD_LIBRARY(tinyxml++_orxonox STATIC ${TINYXML++_FILES})
@@ -38,2 +41,4 @@
   ORXONOX_INSTALL(tinyxml++_orxonox)
 ENDIF()
+
+SET_TARGET_PROPERTIES(tinyxml++_orxonox PROPERTIES VERSION 2.5.3)
Index: code/branches/buildsystem3/src/tinyxml/VERSION
===================================================================
--- code/branches/buildsystem3/src/tinyxml/VERSION	(revision 2669)
+++ code/branches/buildsystem3/src/tinyxml/VERSION	(revision 2670)
@@ -1,1 +1,1 @@
-TinyXML++ trunk checkout revision 98.
+TinyXML++ trunk checkout revision 98. Built on top of TinyXML 2.5.3
Index: code/branches/buildsystem3/src/tolua/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/src/tolua/CMakeLists.txt	(revision 2669)
+++ code/branches/buildsystem3/src/tolua/CMakeLists.txt	(revision 2670)
@@ -32,9 +32,12 @@
 GENERATE_SOURCE_GROUPS(${TOLUA++_FILES})
 
-ADD_COMPILER_FLAGS("-w44996" MSVC)
+# No warnings needed from third party libraries
+ADD_COMPILER_FLAGS("-w")
 
 ADD_LIBRARY(tolua++_orxonox SHARED ${TOLUA++_FILES})
 SET_TARGET_PROPERTIES(tolua++_orxonox PROPERTIES DEFINE_SYMBOL "TOLUA_SHARED_BUILD")
 TARGET_LINK_LIBRARIES(tolua++_orxonox ${LUA_LIBRARIES})
+
+SET_TARGET_PROPERTIES(tolua++_orxonox PROPERTIES VERSION 1.0.92)
 
 ORXONOX_INSTALL(tolua++_orxonox)